﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace pr230_1
{
    // Класс с индексатором: 
    class MyClass {
        // Закрытое поле - ссылка на массив: 
        private int[] nums;
        // Конструктор: 
        public MyClass(int size) { 
            nums = new int[size];
        }
        // Индексатор: 
        public int this[int k] {
            // Аксессор для считывания значения: 
            get {
                return nums[k];
            }
            // Аксессор для присваивания значения: 
            set {
                nums[k] = value;
            }
        }
    }

    // Главный класс:
    class Program
    {
        // Метод для отображения значений элементов 
        // массива из объекта: 
        static void show(MyClass obj) {
            // Целочисленная переменная: 
            int k = 0;
            // Контролируемый блок: 
            try {
                // Конструкция цикла: 
                while(true) {
                    // Отображение значения элемента массива: 
                    Console.Write("|" + obj[k]);
                    // Увеличение значения индексной переменной: 
                    k++;
                }
            }
            // Обработка исключений: 
            catch(IndexOutOfRangeException) { 
                Console.WriteLine("|");
            }
        }

        // Главный метод:
        static void Main()
        {
            // Создание объекта класса:
            MyClass obj = new MyClass(10);
            // Целочисленная переменная: 
            int k = 0;
            // Контролируемый код: 
            try {
                // Циклическая конструкция: 
                do {
                    // Присваивание значения элементу массива
                    // в объекте:
                    obj[k] = 2 * k + 1;
                    // Увеличение значения индексной переменной: 
                    k++;
                } while(true);
            }
            // Обработка исключений: 
            catch(IndexOutOfRangeException) {
                // Отображение содержимого массива из объекта: 
                show(obj);
            }
            // Задержка:
            Console.ReadLine();
        }
    }
}
